#pragma once
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>
#include <note.h>
#include <config/config.h>
#define __alloc(size, t) ((t *) malloc(size * sizeof(t)))
#define strllen(str) (sizeof(str) / sizeof(char))
#define var __auto_type
#define let const __auto_type
#define __offset(off, t) (off * sizeof(t))
#define _e(c) "\x1b[" #c
// Bold format a string
#define _e_b(s) _e(1m) s _e(0m)
// Italicize a string
#define _e_i(s) _e(3m) s _e(0m)

extern int _mzk_friendly;

    #define info(msg, ...) if(_mzk_friendly) printf(_e(1;34m) "[mzk]" _e(0m) " " msg "\n", ##__VA_ARGS__)
    #define step(n, max, msg) if(_mzk_friendly) puts("[" _e(1m) #n _e(0m) "/" #max "] " msg)
    #define step_err(n, max, msg) if(_mzk_friendly) {                                  \
        backlines(1);                                                \
        puts(_e(31m) "[" _e(1m) #n _e(0m) "/" #max "] " msg _e(0m)); \
    }
    #define err(desc) if(_mzk_friendly) {perror(_e(31m) "[err]" _e(0m) " " desc);} else {perror(desc);}
    #define _friendly(code) if(_mzk_friendly) { code }
    #define _unfriendly(code) if(!_mzk_friendly) { code }
    
extern void build_index_filename(char *dest);
extern void build_zk_dir(char *dest);
extern bool rimraf(const char *dir);
extern void backlines(int nLines);
extern bool ends_with(const char *str, const char *substr);
