#include <stdio.h>
#include <note.h>
#include <util.h>
#include <string.h>

int add_note(int argc, char *const *argv) {
    if(argc < 2) {
        puts(
            "mzk\n"
            "(c) 2021 Aleks Rutins\n"
            "Usage: mzk add <name>\n\n"
            "Adds a note with the passed in name."
        );
        return 1;
    }

    step(1, 5, "Opening index file");
    char index_path[256];
    build_index_filename(index_path);
    FILE *indexFile = fopen(index_path, "r+b");

    step(2, 5, "Getting note ID");
    long nextId;
    fseek(indexFile, 0L, SEEK_END);
    nextId = ftell(indexFile) / sizeof(note_t);

    step(3, 5, "Creating note");
    note_t note;
    strcpy(note.title, argv[1]);
    char zkDir[256];
    char notePath[384];
    build_zk_dir(zkDir);
    note.id = nextId;
    sprintf(note.fileName, "%ld.md", nextId);
    sprintf(notePath, "%s/%s", zkDir, note.fileName);

    step(4, 5, "Creating note file");
    FILE *noteFile = fopen(notePath, "w");
    fprintf(noteFile,
        "# %s\n"
        "Put note content here\n"
    , note.title);
    fclose(noteFile);

    step(5, 5, "Writing index");
    fwrite(&note, sizeof(note_t), 1, indexFile);
    fclose(indexFile);
    _friendly(
        info("Done! Edit the note at the path %s", notePath);
    ) _unfriendly(
        printf("%s", notePath);
    )
    return 0;
}