#include <find.h>

#include <string.h>
#include <regex.h>

#include <list.h>
#include <util.h>

regex_t preg;
int result_found;
note_t result;

static int _find_cb(const note_t *note);

note_t find_note(const char *pattern) {
  if(regcomp(&preg, pattern, REG_EXTENDED | REG_ICASE | REG_NOSUB)) {
    err("Failed to compile regular expression");
    result_found = 0;
    goto find_end;
  }

  list_notes(_find_cb);

  regfree(&preg);

find_end:
  if(!result_found) result.id = -1;
  result_found = 0;
  return result;
}

static int _find_cb(const note_t *note) {
  if(!regexec(&preg, note->title, 0, 0, 0)) {
    _list_note(note);
    result.id = note->id;
    strcpy(result.title, note->title);
    strcpy(result.fileName, note->fileName);
    return 1;
  }
  return 0;
}
