#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <util.h>
#include <sys/stat.h>

int init() {
    info("Initializing mzk files...");
    char dir[256];
    strcpy(dir, getenv("HOME"));
    strcat(dir, "/zettelkasten");

    step(1, 3, "Cleaning any current initialization");
    rimraf(dir);

    step(2, 3, "Creating directory ~/zettelkasten");
    mkdir(dir, 0777);
    
    step(3, 3, "Creating index file");
    char indexPath[256];
    strcpy(indexPath, dir);
    strcat(indexPath, "/index.mzk");
    FILE *indexFile = fopen(indexPath, "wb");
    if(indexFile == NULL) {
        step_err(3, 3, "Error creating index file");
        return 1;
    }
    fclose(indexFile);

    info("Done!");
    return 0;
}