#include <util.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <list.h>

int list_notes(int (*callback)(const note_t *)) {
    char indexFileName[256];
    build_index_filename(indexFileName);
    FILE *index = fopen(indexFileName, "rb");
    if(!index) {
        err("Error reading index");
        return 1;
    }
    long nNotes;
    fseek(index, 0L, SEEK_END);
    nNotes = ftell(index) / sizeof(note_t);
    rewind(index);
    note_t *notes = __alloc(nNotes, note_t);
    if(!fread(notes, sizeof(note_t), nNotes, index)) return 1;
    for(int i = 0; i < nNotes; i++) {
        if(callback(notes + i)) break;
    }
    fclose(index);
    free(notes);
    return 0;
}

int list_note_friendly(const note_t *note) {
            char filePath[384];
            build_zk_dir(filePath);
            strcat(filePath, "/");
            strcat(filePath, note->fileName);
            printf("%ld\t" _e_b("%s") "\n", note->id, note->title);
            FILE *noteFile = fopen(filePath, "r");
            if(!noteFile) {
                err("Error reading note");
                return 0;
            }
            // Print first two lines of the note
            char line[128];
            for(int i = 0; i < 2; i++) {
                if(!fgets(line, 128, noteFile)) {
                    err("Error reading note");
                    goto close;
                }
                printf("\t%s", line);
            }
        close:
            fclose(noteFile);
            puts(""); // Extra newline
            return 0;
}

int list_note_unfriendly(const note_t *note) {
        char filePath[384];
        build_zk_dir(filePath);
        strcat(filePath, "/");
        strcat(filePath, note->fileName);
        printf("%ld\t%s\t%s\n", note->id, note->title, filePath);
        return 0;
}
