#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <util.h>
#include <list.h>
#include <find.h>
int _mzk_friendly = 1;

extern int add_note(int argc, char *const *argv);
extern int init();
extern int list_notes();
static const char *HELP = 
_e_b("mzk\n")
"(c) 2021-2024 Aleks Rutins\n"
"Usage: mzk " _e_i("command") " [" _e_i("args") "...]\n"
"\n"
_e_b("Commands:") "\n"
"mzk init\t(RUN THIS FIRST) Initialize needed files and directories\n"
"mzk add " _e_i("name") "\tAdd a note\n"
"mzk list\tList notes\n"
"mzk find " _e_i("pat") "\tFind notes matching a pattern\n"
"mzk help\tPrint this help"
;
void print_help() {
    puts(HELP);
}

int main(int argc, char *const *argv) {
    if(getenv("MZK_UNFRIENDLY") || ends_with(argv[0], "mzk-cli")) _mzk_friendly = 0;
    
    if(argc < 2) {
        print_help();
        return 1;
    }
    if(!strcmp(argv[1], "add")) {
        return add_note(argc - 1, argv + 1); // Pass in argv, starting at 1
    }
    else if(!strcmp(argv[1], "help")) {
        print_help();
    }
    else if(!strcmp(argv[1], "init")) {
        return init();
    }
    else if(!strcmp(argv[1], "list")) {
        return list_notes(_list_note);
    }
    else if(!strcmp(argv[1], "find")) {
        find_note(argv[2]);
    }
    else {
        char cmdline[256];
        snprintf(cmdline, 256, "mzk-%s", argv[1]);
        char which_cmdline[274];
        snprintf(which_cmdline, 274, "which %s > /dev/null", cmdline);

        if(!system(which_cmdline)) {
            execvp(cmdline, argv);
        } else {
            print_help();
        }
        return 1;
    }
    return 0;
}
